﻿Imports System.IO
Imports C1.C1Preview

Public Class Form1

    ' use a specialized class to store VP files
    Private Class VPFile
        Private _path As String
        Public Sub New(path As String)
            _path = path
        End Sub
        Public Overrides Function ToString() As String
            Return Path.GetFileName(_path)
        End Function
        Public ReadOnly Property FullPath() As String
            Get
                Return _path
            End Get
        End Property
    End Class


    'load available VSView documents into list
    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Dim path As String = Application.StartupPath
        Dim pos As Integer = path.IndexOf("\bin")
        path = path.Substring(0, pos) & "\VPDocs"
        For Each file As String In Directory.GetFiles(path, "*.vp")
            comboBox1.Items.Add(New VPFile(file))
        Next
    End Sub

    'user selected a document, show it in C1PrintPreview
    Private Sub comboBox1_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles comboBox1.SelectedIndexChanged
        ' load selected document into VSView control
        Dim fileName As String = DirectCast(comboBox1.SelectedItem, VPFile).FullPath
        loadVP(fileName)
    End Sub

    ' loads the specified VSPrinter document into the preview
    Private Sub loadVP(fileName As String)
        Try
            C1PrintPreviewControl1.PreviewPane.Busy = True
            _vp.LoadDoc(fileName, False)
            ' add pages to C1PrintPreviewControl control
            Dim doc As New C1PrintDocument()
            For page As Short = 1 To _vp.PageCount
                _vp.PreviewPage = page
                doc.PageLayout.PageSettings.TopMargin = 0
                doc.PageLayout.PageSettings.LeftMargin = 0
                If _vp.Picture.Height < _vp.Picture.Width Then
                    doc.PageLayout.PageSettings.Landscape = True
                Else
                    doc.PageLayout.PageSettings.Landscape = False
                End If

                doc.Body.Children.Add(New RenderImage(_vp.Picture))
            Next
            C1PrintPreviewControl1.Document = doc
        Catch
            MessageBox.Show(String.Format("Error loading {0}", fileName))
        Finally
            C1PrintPreviewControl1.PreviewPane.Busy = False
        End Try
    End Sub

End Class